<!DOCTYPE html>
<html>
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<title>How to Autocomplete textbox using JavaScript and PHP</title>
  <style type="text/css">
	.clear{
	 	clear:both;
	 	margin-top: 20px;
	}

	.autocomplete{
		width: 250px;
		position: relative;
	}
	.autocomplete #searchResult{
	 	list-style: none;
	 	padding: 0px;
	 	width: 100%;
	 	position: absolute;
	 	margin: 0;
	 	background: white;
	}

	.autocomplete #searchResult li{
	 	background: #F1F4FFFF;
	 	padding: 4px;
	 	margin-bottom: 1px;
	}

	.autocomplete #searchResult li:nth-child(even){
	 	background: #A2A2A1FF;
	 	color: white;
	}

	.autocomplete #searchResult li:hover{
	 	cursor: pointer;
	}

	.autocomplete input[type=text]{
	 	padding: 5px;
	 	width: 100%;
	 	letter-spacing: 1px;
	}
	</style>
</head>
<body>
  <h1 style="font-size: 20px;text-align: center;margin-bottom: 25px;margin-top: 20px;">How to Autocomplete textbox using JavaScript and PHP</h1>
	<div class='autocomplete'>
		<div>Search Name </div>
		<div>
		   <input type="text" id="txt_search" name="txt_search" onkeyup="searchResult(this.value);">
		</div>
		<ul id="searchResult"></ul>

		<div class="clear"></div>
		<div id="userDetail"></div>
	</div>

	<!-- Script -->
  <script type="text/javascript">

		// Search results
		function searchResult(search){

			if(search.length > 0){

		        // AJAX request
		        var xhttp = new XMLHttpRequest();
		        xhttp.open("POST", "ajaxfile.php", true);
		        xhttp.setRequestHeader("Content-Type", "application/json");
		        xhttp.onreadystatechange = function() {
		           	if (this.readyState == 4 && this.status == 200) {

		               	// Response
		               	var response = JSON.parse(this.responseText);

		               	var len = 0;
								    if(response != null){
								        len = response.length;
								    }

					    			if(len > 0){

			               	// <ul id="searchResult"> element
			                var searchResult = document.getElementById('searchResult');

			                // Empty the search result
			                searchResult.innerHTML = "";

			                for( var i = 0; i<len; i++){
			                    var id = response[i]['id'];
			                    var name = response[i]['name'];

			                    // Add <li > to searchResult
									        var liel = document.createElement('li');
									        liel.value = id;
									        liel.innerHTML = name;

									        // Add click event to fetch details on click
									        liel.addEventListener('click', get_userdetails);

									        searchResult.appendChild(liel);

			                }
		                }
		            }
		        };
		        var data = {request: 'suggestionList',search: search};
		        xhttp.send(JSON.stringify(data));

		   	}else{
		   		document.getElementById('searchResult').innerHTML = "";
		   	}

		}

		// Get clicked item Data
		function get_userdetails(evt){

			// Read clicked <li > value and text
			var userid = evt.currentTarget.value;
			var text = evt.currentTarget.innerText;

			// Empty the search result and user Details
			document.getElementById('searchResult').innerHTML = "";
			document.getElementById('userDetail').innerHTML = "";

			// Update searchbox text with selected item
			document.getElementById('txt_search').value = text;

			// AJAX request
		    var xhttp = new XMLHttpRequest();
		    xhttp.open("POST", "ajaxfile.php", true);
		    xhttp.setRequestHeader("Content-Type", "application/json");
		    xhttp.onreadystatechange = function() {
		        if (this.readyState == 4 && this.status == 200) {

		            // Response
		            var response = JSON.parse(this.responseText);

		            // Check status
								if(response.status == 1){

									// Read user data
									var data = response.data;
			            var id = data.id;
			            var name = data.name;
			            var email = data.email;
			            var city = data.city;

			            // <div id="userDetail"> element
			            var userDetail = document.getElementById('userDetail');

			            // Append <p > element to <div id="userDetail">
			            // ID
			            var para_id = document.createElement('p');
									para_id.innerHTML = 'ID : ' + id;
									userDetail.appendChild(para_id);

									// Name
			            var para_name = document.createElement('p');
									para_name.innerHTML = 'NAME : ' + name;
									userDetail.appendChild(para_name);

									// Email
			            var para_email = document.createElement('p');
									para_email.innerHTML = 'EMAIL : ' + email;
									userDetail.appendChild(para_email);

									// City
			            var para_city = document.createElement('p');
									para_city.innerHTML = 'City : ' + city;
									userDetail.appendChild(para_city);

		            }
		        }
		    };
		    var data = {request: 'userdetails',userid: userid};
		    xhttp.send(JSON.stringify(data));
		}
	</script>
</body>
</html>
